/* ***********************************************************
 * This file was automatically generated on 2019-06-18.      *
 *                                                           *
 * Rust Bindings Version 2.0.11                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Measures Particulate Matter concentration (PM1.0, PM2.5 and PM10).
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/ParticulateMatter_Bricklet_Rust.html).
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::GetRequestSender,
};
pub enum ParticulateMatterBrickletFunction {
    GetPmConcentration,
    GetPmCount,
    SetEnable,
    GetEnable,
    GetSensorInfo,
    SetPmConcentrationCallbackConfiguration,
    GetPmConcentrationCallbackConfiguration,
    SetPmCountCallbackConfiguration,
    GetPmCountCallbackConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackPmConcentration,
    CallbackPmCount,
}
impl From<ParticulateMatterBrickletFunction> for u8 {
    fn from(fun: ParticulateMatterBrickletFunction) -> Self {
        match fun {
            ParticulateMatterBrickletFunction::GetPmConcentration => 1,
            ParticulateMatterBrickletFunction::GetPmCount => 2,
            ParticulateMatterBrickletFunction::SetEnable => 3,
            ParticulateMatterBrickletFunction::GetEnable => 4,
            ParticulateMatterBrickletFunction::GetSensorInfo => 5,
            ParticulateMatterBrickletFunction::SetPmConcentrationCallbackConfiguration => 6,
            ParticulateMatterBrickletFunction::GetPmConcentrationCallbackConfiguration => 7,
            ParticulateMatterBrickletFunction::SetPmCountCallbackConfiguration => 8,
            ParticulateMatterBrickletFunction::GetPmCountCallbackConfiguration => 9,
            ParticulateMatterBrickletFunction::GetSpitfpErrorCount => 234,
            ParticulateMatterBrickletFunction::SetBootloaderMode => 235,
            ParticulateMatterBrickletFunction::GetBootloaderMode => 236,
            ParticulateMatterBrickletFunction::SetWriteFirmwarePointer => 237,
            ParticulateMatterBrickletFunction::WriteFirmware => 238,
            ParticulateMatterBrickletFunction::SetStatusLedConfig => 239,
            ParticulateMatterBrickletFunction::GetStatusLedConfig => 240,
            ParticulateMatterBrickletFunction::GetChipTemperature => 242,
            ParticulateMatterBrickletFunction::Reset => 243,
            ParticulateMatterBrickletFunction::WriteUid => 248,
            ParticulateMatterBrickletFunction::ReadUid => 249,
            ParticulateMatterBrickletFunction::GetIdentity => 255,
            ParticulateMatterBrickletFunction::CallbackPmConcentration => 10,
            ParticulateMatterBrickletFunction::CallbackPmCount => 11,
        }
    }
}
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmConcentration {
    pub pm10: u16,
    pub pm25: u16,
    pub pm100: u16,
}
impl FromByteSlice for PmConcentration {
    fn bytes_expected() -> usize { 6 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmConcentration {
        PmConcentration {
            pm10: <u16>::from_le_byte_slice(&bytes[0..2]),
            pm25: <u16>::from_le_byte_slice(&bytes[2..4]),
            pm100: <u16>::from_le_byte_slice(&bytes[4..6]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmCount {
    pub greater03um: u16,
    pub greater05um: u16,
    pub greater10um: u16,
    pub greater25um: u16,
    pub greater50um: u16,
    pub greater100um: u16,
}
impl FromByteSlice for PmCount {
    fn bytes_expected() -> usize { 12 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmCount {
        PmCount {
            greater03um: <u16>::from_le_byte_slice(&bytes[0..2]),
            greater05um: <u16>::from_le_byte_slice(&bytes[2..4]),
            greater10um: <u16>::from_le_byte_slice(&bytes[4..6]),
            greater25um: <u16>::from_le_byte_slice(&bytes[6..8]),
            greater50um: <u16>::from_le_byte_slice(&bytes[8..10]),
            greater100um: <u16>::from_le_byte_slice(&bytes[10..12]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SensorInfo {
    pub sensor_version: u8,
    pub last_error_code: u8,
    pub framing_error_count: u8,
    pub checksum_error_count: u8,
}
impl FromByteSlice for SensorInfo {
    fn bytes_expected() -> usize { 4 }
    fn from_le_byte_slice(bytes: &[u8]) -> SensorInfo {
        SensorInfo {
            sensor_version: <u8>::from_le_byte_slice(&bytes[0..1]),
            last_error_code: <u8>::from_le_byte_slice(&bytes[1..2]),
            framing_error_count: <u8>::from_le_byte_slice(&bytes[2..3]),
            checksum_error_count: <u8>::from_le_byte_slice(&bytes[3..4]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmConcentrationCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for PmConcentrationCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmConcentrationCallbackConfiguration {
        PmConcentrationCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmCountCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for PmCountCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmCountCallbackConfiguration {
        PmCountCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmConcentrationEvent {
    pub pm10: u16,
    pub pm25: u16,
    pub pm100: u16,
}
impl FromByteSlice for PmConcentrationEvent {
    fn bytes_expected() -> usize { 6 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmConcentrationEvent {
        PmConcentrationEvent {
            pm10: <u16>::from_le_byte_slice(&bytes[0..2]),
            pm25: <u16>::from_le_byte_slice(&bytes[2..4]),
            pm100: <u16>::from_le_byte_slice(&bytes[4..6]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct PmCountEvent {
    pub greater03um: u16,
    pub greater05um: u16,
    pub greater10um: u16,
    pub greater25um: u16,
    pub greater50um: u16,
    pub greater100um: u16,
}
impl FromByteSlice for PmCountEvent {
    fn bytes_expected() -> usize { 12 }
    fn from_le_byte_slice(bytes: &[u8]) -> PmCountEvent {
        PmCountEvent {
            greater03um: <u16>::from_le_byte_slice(&bytes[0..2]),
            greater05um: <u16>::from_le_byte_slice(&bytes[2..4]),
            greater10um: <u16>::from_le_byte_slice(&bytes[4..6]),
            greater25um: <u16>::from_le_byte_slice(&bytes[6..8]),
            greater50um: <u16>::from_le_byte_slice(&bytes[8..10]),
            greater100um: <u16>::from_le_byte_slice(&bytes[10..12]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Measures Particulate Matter concentration (PM1.0, PM2.5 and PM10)
#[derive(Clone)]
pub struct ParticulateMatterBricklet {
    device: Device,
}
impl ParticulateMatterBricklet {
    pub const DEVICE_IDENTIFIER: u16 = 2110;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Particulate Matter Bricklet";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> ParticulateMatterBricklet {
        let mut result = ParticulateMatterBricklet { device: Device::new([2, 0, 0], uid, req_sender, 0) };
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetPmConcentration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetPmCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetEnable) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetEnable) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetSensorInfo) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetPmConcentrationCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetPmConcentrationCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetPmCountCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetPmCountCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::WriteFirmware) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::SetStatusLedConfig) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(ParticulateMatterBrickletFunction::GetIdentity) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::particulate_matter_bricklet::ParticulateMatterBricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::particulate_matter_bricklet::ParticulateMatterBricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: ParticulateMatterBrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: ParticulateMatterBrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] { self.device.api_version }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_pm_concentration_callback_configuration`].
    ///
    /// The parameters are the same as [`get_pm_concentration`].
    ///
    /// [`get_pm_concentration`]: #method.get_pm_concentration
    /// [`set_pm_concentration_callback_configuration`]: #method.set_pm_concentration_callback_configuration
    pub fn get_pm_concentration_callback_receiver(&self) -> ConvertingCallbackReceiver<PmConcentrationEvent> {
        self.device.get_callback_receiver(u8::from(ParticulateMatterBrickletFunction::CallbackPmConcentration))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_pm_count_callback_configuration`].
    ///
    /// The parameters are the same as [`get_pm_count`].
    ///
    /// [`get_pm_count`]: #method.get_pm_count
    /// [`set_pm_count_callback_configuration`]: #method.set_pm_count_callback_configuration
    pub fn get_pm_count_callback_receiver(&self) -> ConvertingCallbackReceiver<PmCountEvent> {
        self.device.get_callback_receiver(u8::from(ParticulateMatterBrickletFunction::CallbackPmCount))
    }

    /// Returns the particulate matter concentration in µg/m³, broken down as:
    ///
    /// * PM\ :sub:`1.0`\ ,
    /// * PM\ :sub:`2.5`\  and
    /// * PM\ :sub:`10.0`\ .
    ///
    /// If the sensor is disabled (see [`set_enable`]) then the last known good
    /// values from the sensor are returned.
    ///
    /// [`set_enable`]: #method.set_enable
    pub fn get_pm_concentration(&self) -> ConvertingReceiver<PmConcentration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetPmConcentration), payload)
    }

    /// Returns the number of particulates in 100 ml of air, broken down by their
    /// diameter:
    ///
    /// * greater 0.3µm,
    /// * greater 0.5µm,
    /// * greater 1.0µm,
    /// * greater 2.5µm,
    /// * greater 5.0µm and
    /// * greater 10.0µm.
    ///
    /// If the sensor is disabled (see [`set_enable`]) then the last known good
    /// value from the sensor is returned.
    ///
    /// [`set_enable`]: #method.set_enable
    pub fn get_pm_count(&self) -> ConvertingReceiver<PmCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetPmCount), payload)
    }

    /// Enables/Disables the fan and the laser diode of the sensors. The sensor is
    /// enabled by default.
    ///
    /// The sensor takes about 30 seconds after it is enabled to settle and produce stable
    /// values.
    ///
    /// The laser diode has a lifetime of about 8000 hours. If you want to measure in
    /// an interval with a long idle time (e.g. hourly) you should turn the
    /// laser diode off between the measurements.
    pub fn set_enable(&self, enable: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<bool>::to_le_byte_vec(enable));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::SetEnable), payload)
    }

    /// Returns the state of the sensor as set by [`set_enable`].
    ///
    /// [`set_enable`]: #method.set_enable
    pub fn get_enable(&self) -> ConvertingReceiver<bool> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetEnable), payload)
    }

    /// Returns information about the sensor:
    ///
    /// * the sensor version number,
    /// * the last error code reported by the sensor (0 means no error) and
    /// * the number of framing and checksum errors that occurred in the communication
    ///   with the sensor.
    pub fn get_sensor_info(&self) -> ConvertingReceiver<SensorInfo> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetSensorInfo), payload)
    }

    /// The period in ms is the period with which the [`get_pm_concentration_callback_receiver`]
    /// receiver is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// The default value is (0, false).
    ///
    /// [`get_pm_concentration_callback_receiver`]: #method.get_pm_concentration_callback_receiver
    pub fn set_pm_concentration_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::SetPmConcentrationCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// [`set_pm_concentration_callback_configuration`].
    ///
    /// [`set_pm_concentration_callback_configuration`]: #method.set_pm_concentration_callback_configuration
    pub fn get_pm_concentration_callback_configuration(&self) -> ConvertingReceiver<PmConcentrationCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetPmConcentrationCallbackConfiguration), payload)
    }

    /// The period in ms is the period with which the [`get_pm_count_callback_receiver`] receiver
    /// is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// The default value is (0, false).
    ///
    /// [`get_pm_count_callback_receiver`]: #method.get_pm_count_callback_receiver
    pub fn set_pm_count_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::SetPmCountCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// [`set_pm_count_callback_configuration`].
    ///
    /// [`set_pm_count_callback_configuration`]: #method.set_pm_count_callback_configuration
    pub fn get_pm_count_callback_configuration(&self) -> ConvertingReceiver<PmCountCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetPmCountCallbackConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(ParticulateMatterBrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// [`set_bootloader_mode`]: #method.set_bootloader_mode
    ///
    /// Associated constants:
    /// * PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* PARTICULATE_MATTER_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`write_firmware`]: #method.write_firmware
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`set_write_firmware_pointer`]: #method.set_write_firmware_pointer
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(ParticulateMatterBrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// [`set_status_led_config`]: #method.set_status_led_config
    ///
    /// Associated constants:
    /// * PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* PARTICULATE_MATTER_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(ParticulateMatterBrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(ParticulateMatterBrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(ParticulateMatterBrickletFunction::GetIdentity), payload)
    }
}
